//+------------------------------------------------------------------+
//|                                           AO_Sledopit  indicator |
//|                                                                  |
//+------------------------------------------------------------------+

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1  Black
#property  indicator_color2  LimeGreen
#property  indicator_color3  DarkTurquoise
#property  indicator_color4    DarkViolet
#property  indicator_color5    Red   
#property  indicator_color6    Orange
#property  indicator_color7    Gray







#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  1
#property  indicator_width4  1
#property  indicator_width5  1
#property  indicator_width6  1
#property  indicator_width7  1


#property indicator_level1 0
//#property indicator_levelstyle DRAW_ZIGZAG
#property indicator_levelcolor Black
#property indicator_levelwidth 1
//---- indicator parameters
extern int MA_1=5;
extern int Metod_MA_1=1;
extern int Price_MA_1=0;
extern string           __________ = "----------";
extern int MA_2=21;
extern int Metod_MA_2=1;
extern int Price_MA_2=0;
extern string           _________ = "----------";
extern int MA_3=55;
extern int Metod_MA_3=1;
extern int Price_MA_3=0;

extern string           ________ = "----------";
extern int MA_4=89;
extern int Metod_MA_4=1;
extern int Price_MA_4=0;
extern string           ______ = "----------";
extern bool pokaz_144=true;
extern int MA_5=144;
extern int Metod_MA_5=1;
extern int Price_MA_5=0;
extern string           _____ = "----------";
extern bool pokaz_233=true;
extern int MA_6=233;
extern int Metod_MA_6=1;
extern int Price_MA_6=0;
extern string           ____ = "----------";
extern bool pokaz_377=true;
extern int MA_7=377;
extern int Metod_MA_7=1;
extern int Price_MA_7=0;
extern string           ___ = "----------";
extern bool pokaz_610=true;
extern int MA_8=610;
extern int Metod_MA_8=1;
extern int Price_MA_8=0;

//---- indicator buffers
double     Buffer_21[];
double     Buffer_55[];
double     Buffer_89[];
double     Buffer_144[];
double     Buffer_233[];
double     Buffer_377[];
double     Buffer_610[];


datetime LastTime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);
   
   SetIndexDrawBegin(0,MA_2);
   SetIndexDrawBegin(1,MA_3);
   SetIndexDrawBegin(2,MA_4);
   
   SetIndexDrawBegin(3,MA_5);

   SetIndexDrawBegin(4,MA_6);

   SetIndexDrawBegin(5,MA_7);
   
   SetIndexDrawBegin(6,MA_8);
   
   IndicatorDigits(Digits);
   
//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer_21);
   SetIndexBuffer(1,Buffer_55);
   SetIndexBuffer(2,Buffer_89);
   if (pokaz_144)
   SetIndexBuffer(3,Buffer_144);
   if (pokaz_233)
   SetIndexBuffer(4,Buffer_233);
      if (pokaz_377)
   SetIndexBuffer(5,Buffer_377);
   if (pokaz_610)
   SetIndexBuffer(6,Buffer_610);
   
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("AO_Sledopit");
   SetIndexLabel(0,"5-21");
   SetIndexLabel(1,"21-55");
   SetIndexLabel(2,"55-89");
   SetIndexLabel(3,"89-144");
   SetIndexLabel(4,"144-233");
   SetIndexLabel(5,"233-377");
   SetIndexLabel(6,"377-610");

//   SetIndexLabel(0,NULL);
//   SetIndexLabel(1,NULL);
//   SetIndexLabel(2,NULL);   

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
           int  LastBars = iBarShift(NULL, 0, LastTime);
           if(LastTime != Time[0] && LastBars > 1) 
             { 
//----    5  21
   for(int i=0; i<limit; i++)
      Buffer_21[i]=iMA(NULL,0,MA_1,0,Metod_MA_1,Price_MA_1,i)-iMA(NULL,0,MA_2,0,Metod_MA_2,Price_MA_2,i);
//----    21  55
   for(i=0; i<limit; i++)
      Buffer_55[i]=iMA(NULL,0,MA_2,0,Metod_MA_2,Price_MA_2,i)-iMA(NULL,0,MA_3,0,Metod_MA_3,Price_MA_3,i);
//----    55  89
   for(i=0; i<limit; i++)
      Buffer_89[i]=iMA(NULL,0,MA_3,0,Metod_MA_3,Price_MA_3,i)-iMA(NULL,0,MA_4,0,Metod_MA_4,Price_MA_4,i);
//----    89  144
   for(i=0; i<limit; i++)
      Buffer_144[i]=iMA(NULL,0,MA_4,0,Metod_MA_4,Price_MA_4,i)-iMA(NULL,0,MA_5,0,Metod_MA_5,Price_MA_5,i);
      
      
//----    144  233
   for(i=0; i<limit; i++)
      Buffer_233[i]=iMA(NULL,0,MA_5,0,Metod_MA_5,Price_MA_5,i)-iMA(NULL,0,MA_6,0,Metod_MA_6,Price_MA_6,i);
//----    233  377
   for(i=0; i<limit; i++)
      Buffer_377[i]=iMA(NULL,0,MA_6,0,Metod_MA_6,Price_MA_6,i)-iMA(NULL,0,MA_7,0,Metod_MA_7,Price_MA_7,i);
//----    377  610
   for(i=0; i<limit; i++)
      Buffer_610[i]=iMA(NULL,0,MA_7,0,Metod_MA_7,Price_MA_7,i)-iMA(NULL,0,MA_8,0,Metod_MA_8,Price_MA_8,i);



       LastTime = Time[0];        
     }
     
   return(0);
  }
//+------------------------------------------------------------------+